ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.5 by root, Thu Mar 8 15:19:08 2007 UTC vs.
Revision 1.75 by root, Mon Nov 2 11:50:20 2009 UTC

6my $exec_prefix = "@exec_prefix@"; 6my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 7my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 8my $DATADIR = "@datadir@/@PACKAGE@";
9 9
10my $CONVERT = "@CONVERT@"; 10my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 11#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 12my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 13my $RSYNC = "@RSYNC@";
14my $PNGNQ = "@PNGNQ@";
14 15
15use Getopt::Long; 16use Getopt::Long;
17use File::Temp;
18use POSIX ();
19use Carp;
20
16use Coro::Event; 21use Coro::EV;
17use AnyEvent; 22use AnyEvent;
23use YAML::XS ();
24use JSON::XS ();
18use IO::AIO (); 25use IO::AIO ();
19use File::Temp; 26
20use Crossfire;
21use Coro; 27use Coro 5.12;
22use Coro::AIO; 28use Coro::AIO;
23use POSIX (); 29use Coro::Util;
30use Coro::Channel;
31use Coro::Storable; $Storable::canonical = 1;
32
33use Deliantra;
34
35$SIG{QUIT} = sub { Carp::cluck "QUIT" };
24 36
25sub usage { 37sub usage {
26 warn <<EOF; 38 warn <<EOF;
27Usage: cfutil [-v] [-q] [--force] [--cache] 39Usage: cfutil [-v] [-q] [--force] [--cache]
28 [--install-arch path] 40 [--install-arch path]
40my $CACHE = 0; 52my $CACHE = 0;
41my $FORCE; 53my $FORCE;
42my $TMPDIR = "/tmp/cfutil$$~"; 54my $TMPDIR = "/tmp/cfutil$$~";
43my $TMPFILE = "aaaa0"; 55my $TMPFILE = "aaaa0";
44 56
57our %COLOR = (
58 black => 0,
59 white => 1,
60 navy => 2,
61 red => 3,
62 orange => 4,
63 blue => 5,
64 darkorange => 6,
65 green => 7,
66 lightgreen => 8,
67 grey => 9,
68 brown => 10,
69 gold => 11,
70 tan => 12,
71);
72
45END { system "rm", "-rf", $TMPDIR } 73END { system "rm", "-rf", $TMPDIR }
46 74
47Event->signal (signal => "INT", cb => sub { exit 1 }); 75my $s_INT = EV::signal INT => sub { exit 1 };
48Event->signal (signal => "TERM", cb => sub { exit 1 }); 76my $s_TERM = EV::signal TERM => sub { exit 1 };
49 77
50mkdir $TMPDIR, 0700 78mkdir $TMPDIR, 0700
51 or die "$TMPDIR: $!"; 79 or die "$TMPDIR: $!";
52 80
53sub fork_sub(&) { 81sub fork_sub(&) {
66} 94}
67 95
68sub inst_maps($) { 96sub inst_maps($) {
69 my (undef, $path) = @_; 97 my (undef, $path) = @_;
70 98
71 print "installing '$path' to '$DATADIR/maps'\n\n"; 99 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
72 100
73 if (!-f "$path/regions") { 101 if (!-f "$path/regions") {
74 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 102 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
75 exit 1 unless $FORCE; 103 exit 1 unless $FORCE;
76 } 104 }
77 105
78 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"; 106 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
107 "$path/.", "$DATADIR/maps/.",
108 "--exclude", "CVS", "--exclude", "/world-precomposed",
109 "--delete", "--delete-excluded"
110 and die "map installation failed.\n";
111
112 print "maps installed successfully.\n";
79} 113}
80 114
81{ 115{
82 our @PNG; 116 our %ANIMINFO;
117 our %FACEINFO;
118 our %RESOURCE;
83 our @ARC; 119 our @ARC;
120 our %ARC;
121 our $TRS;
84 our $NFILE; 122 our $NFILE;
85 our @FACE;
86 our $ANIM; 123 our $PATH;
87 124
88 our (@png, @trs, @arc); # files we are interested in 125 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
89 126
127 our $c_arc = new Coro::Channel;
128 our $c_trs = new Coro::Channel;
129 our $c_res = new Coro::Channel;
130
131 our @c_png;
132
90 sub commit_png { 133 sub commit_png($$$) {
91 my ($name, $data) = @_; 134 my ($name, $data, $T) = @_;
92 135
93 push @PNG, [$name => $data]; 136 $FACEINFO{$name}{"data$T"} = $data;
94 } 137 }
95 138
96 sub process_png { 139 sub process_png {
97 while (@png) { 140 while (@c_png) {
98 my $path = pop @png; 141 my ($path, $delete) = @{pop @c_png};
99 142
100 my $png; 143 my $png;
101 aio_lstat $path; 144 aio_lstat $path;
102 my ($size, $mtime) = (stat _)[7,9]; 145 my ($size, $mtime) = (stat _)[7,9];
103 146
104 if (0 > aio_load $path, $png) { 147 if (0 > aio_load $path, $png) {
105 warn "$path: $!, skipping.\n"; 148 warn "$path: $!, skipping.\n";
106 next; 149 next;
107 } 150 }
108 151
109 # quickly extratc width and height of the (necessarily PNG) image 152 my $stem = $path;
110 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 153 my $T;
111 warn "$path: not a recongized png file, skipping.\n";
112 next;
113 }
114 154
115 my ($w, $h) = unpack "NN", $1; 155 if ($stem =~ s/\.32x32\.png~?$//) {
116
117 (my $face = $path) =~ s/^.*\///;
118 my $T = 32; 156 $T = 32;
119 157 } elsif ($stem =~ s/\.64x64\.png~?$//) {
120 unless ($face =~ s/\.base\.(...)\.png$/.$1/) { 158 $T = 64;
159 } else {
121 warn "$path: weird filename, skipping.\n"; 160 warn "$path: weird filename, skipping.\n";
122 next; 161 next;
123 } 162 }
163
164 # quickly extract width and height of the (necessarily PNG) image
165 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
166 warn "$path: not a recognized png file, skipping.\n";
167 next;
168 }
169
170 my ($w, $h) = unpack "NN", $1;
124 171
125 if ($w < $T || $h < $T) { 172 if ($w < $T || $h < $T) {
126 warn "$path: too small ($w $h), skipping.\n"; 173 warn "$path: too small ($w $h), skipping.\n";
127 next; 174 next;
128 } 175 }
130 if ($w % $T || $h % $T) { 177 if ($w % $T || $h % $T) {
131 warn "$path: weird png size ($w $h), skipping.\n"; 178 warn "$path: weird png size ($w $h), skipping.\n";
132 next; 179 next;
133 } 180 }
134 181
182 (my $base = $stem) =~ s/^.*\///;
183
184 my $fi = $FACEINFO{$base};
185 unless ($fi) {
186 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
187 #next;
188 }
189
190 my $arc = $fi->{arc} || { };
191
192 unless ($path =~ /~$/) {
193 # possibly enlarge
194 if (0 > aio_stat "$stem.64x64.png") {
195 my $other = "$stem.64x64.png~";
196
197 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
198 fork_sub {
199 my $CROP;
200 my $SRC = "png:\Q$path\E";
201
202 my $is_floor = $arc->{is_floor};
203 my $is_wall = 0;
204
205 my ($wall_pfx, $wall_dir, $wall_sfx);
206
207 if (
208 !$is_floor
209 && !$arc->{alive}
210 && $arc->{move_block} eq "all"
211 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
212 ) {
213 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
214
215 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
216 $is_wall = 1;
217 }
218 }
219
220 if ($is_wall || $is_floor) {
221 # add a 4px border and add other images around it
222 $CROP = "-shave 8x8 +repage";
223
224 $w += 8;
225 $h += 8;
226
227 $SRC = "-size ${w}x${h} xc:transparent";
228 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
229
230 # 8 surrounding images
231 for (
232 # x y b r0 r1
233 [-1, -1, 0, 6],
234 [ 0, -1, 1, 10, 14],
235 [+1, -1, 0, 12],
236
237 [-1, 0, 8, 5, 7],
238 #
239 [+1, 0, 2, 5, 13],
240
241 [-1, +1, 0, 3],
242 [ 0, +1, 4, 10, 11],
243 [+1, +1, 0, 9],
244 ) {
245 my ($x, $y, $d, $r0, $r1) = @$_;
246
247 my $tile = $is_floor ? $path
248 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
249 : die;
250
251 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
252 "\Q$tile",
253 $x * ($w - 8) + 4,
254 $y * ($h - 8) + 4;
255 }
256 }
257
258 system "convert -depth 8 $SRC rgba:-"
259 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
260 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
261 and die "convert/cfhq2xa pipeline error: status $? ($!)";
262 system $OPTIPNG, "-i0", "-q", "$other~";
263 die "$other~ has zero size, aborting." unless -s "$other~";
264 rename "$other~", $other;
265 };
266 }
267
268 push @c_png, [$other, !$CACHE];
269 }
270
271 # possibly scale down
272 if (0 > aio_stat "$stem.32x32.png") {
273 my $other = "$stem.32x32.png~";
274
275 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
276 fork_sub {
277 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
278 system $OPTIPNG, "-i0", "-q", "$other~";
279
280 # reduce smoothfaces >10000 bytes
281 # obsolete, no longer required
282 if (0 && $stem =~ /_S\./ && (-s "$other~") > 10000) {
283 my $ncolor = 256;
284 while () {
285 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
286 system $OPTIPNG, "-i0", "-q", "$other~~";
287 last if 10000 > -s "$other~~";
288 $ncolor = int $ncolor * 0.9;
289 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
290 }
291
292 printf "reduced %s from %d to %d bytes using %d colours.\n",
293 $other, -s "$other~", -s "$other~~", $ncolor
294 if $VERBOSE >= 2;
295 rename "$other~~", "$other~";
296 }
297
298 die "$other~ has zero size, aborting." unless -s "$other~";
299 rename "$other~", $other;
300 };
301 }
302
303 #warn "scaled down $path to $other\n";#d#
304 push @c_png, [$other, !$CACHE];
305 }
306 }
307
308 (my $face = $stem) =~ s/^.*\///;
309
310 # split all bigfaces, but avoid smoothfaces (*_S)
135 if (($w > $T || $h > $T) && $face !~ /_S\./) { 311 if (($w > $T || $h > $T) && $face !~ /_S\./) {
136 # split 312 # split
137 my @tile; 313 my @tile;
138 for my $x (0 .. (int $w / $T) - 1) { 314 for my $x (0 .. (int $w / $T) - 1) {
139 for my $y (0 .. (int $h / $T) - 1) { 315 for my $y (0 .. (int $h / $T) - 1) {
147 my @todo = grep { $_->[3] <= $mtime } @tile; 323 my @todo = grep { $_->[3] <= $mtime } @tile;
148 if (@todo) { 324 if (@todo) {
149 fork_sub { 325 fork_sub {
150 open my $convert, "|-", $CONVERT, 326 open my $convert, "|-", $CONVERT,
151 "png:-", 327 "png:-",
152 -negate,#d#
153 (map { 328 (map {
154 ( 329 (
155 "(", 330 "(",
156 "+clone", 331 "+clone",
157 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 332 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
333 "+repage",
334 -quality => "00",
158 -write => "png:$_->[2]~", 335 -write => "png32:$_->[2]~",
159 "+delete", 336 "+delete",
160 ")", 337 ")",
161 ) 338 )
162 } @todo), 339 } @todo),
163 "null:"; 340 "null:";
167 close $convert; 344 close $convert;
168 345
169 # pass 2, optimise, and rename 346 # pass 2, optimise, and rename
170 for (@todo) { 347 for (@todo) {
171 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 348 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
349 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
172 rename "$_->[2]~", $_->[2]; 350 rename "$_->[2]~", $_->[2];
173 } 351 }
174 }; 352 };
175 } 353 }
176 354
180 358
181 if (0 > aio_load $file, $tile) { 359 if (0 > aio_load $file, $tile) {
182 die "$path: unable to read tile +$x+$y, aborting.\n"; 360 die "$path: unable to read tile +$x+$y, aborting.\n";
183 } 361 }
184 IO::AIO::aio_unlink $file unless $CACHE; 362 IO::AIO::aio_unlink $file unless $CACHE;
185 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 363 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T;
186 } 364 }
187 } else { 365 } else {
188 # use as-is (either small, use smooth) 366 # use as-is (either small, use smooth)
189 commit_png $face, $png; 367 commit_png $face, $png, $T;
190 } 368 }
369
370 aio_unlink $path if $delete;
191 } 371 }
192 } 372 }
193 373
194 sub process_arc { 374 sub process_arc {
195 while (@arc) { 375 while (my $job = $c_arc->get) {
196 my ($dir, $file) = @{pop @arc}; 376 my ($dir, $file) = @$job;
197 377
198 my $arc; 378 my $arc;
199 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 379 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
200 380
201 my $arc = read_arch "$dir/$file"; 381 my $arc = read_arch "$dir/$file";
202 for my $o (values %$arc) { 382 for my $o (values %$arc) {
203 push @ARC, $o; 383 push @ARC, $o;
384 for (my $m = $o; $m; $m = $m->{more}) {
385 $ARC{$m->{_name}} = $m;
386 }
387
388 $o->{editor_folder} ||= $dir;
389
390 my $visibility = delete $o->{visibility};
391 my $magicmap = delete $o->{magicmap};
392
393 # find upper left corner :/
394 # omg, this is sooo broken
204 my ($dx, $dy); 395 my ($dx, $dy);
205 # omg, this is sooo broken
206 for (my $o = $o; $o; $o = $o->{more}) { 396 for (my $o = $o; $o; $o = $o->{more}) {
207 $dx = $o->{x} if $o->{x} < $dx; 397 $dx = $o->{x} if $o->{x} < $dx;
208 $dy = $o->{y} if $o->{y} < $dy; 398 $dy = $o->{y} if $o->{y} < $dy;
209 } 399 }
400
210 for (my $o = $o; $o; $o = $o->{more}) { 401 for (my $o = $o; $o; $o = $o->{more}) {
211 my $x = $o->{x} - $dx; 402 my $x = $o->{x} - $dx;
212 my $y = $o->{y} - $dy; 403 my $y = $o->{y} - $dy;
213 if ($x|$y) { 404
214 $_ .= "+$x+$y" for $o->{face}, @{$o->{anim} || []}; 405 my $ext = $x|$y ? "+$x+$y" : "";
215 } 406
216 } 407 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
408
409 $visibility = delete $o->{visibility} if exists $o->{visibility};
410 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
411
217 if (my $anim = delete $o->{anim}) { 412 my $anim = delete $o->{anim};
413
414 if ($anim) {
415 # possibly add $ext to the animation name to avoid
416 # the need to specify archnames for all parts
417 # of a multipart archetype.
218 $o->{animation} = $o->{_name}; 418 $o->{animation} = "$o->{_name}";
219 $ANIM .= join "", map "$_\n", 419 my $facings = 1;
220 "anim $o->{_name}", 420 my @frames;
421
422 for (@$anim) {
423 if (/^facings\s+(\d+)/) {
424 $facings = $1*1;
425 } elsif (/^blank.x11$|^empty.x11$/) {
426 push @frames, $_;
427 } else {
428 push @frames, "$_$ext";
221 @$anim, 429 }
222 "mina"; 430 }
431
432 $ANIMINFO{$o->{animation}} = {
433 facings => $facings,
434 frames => \@frames,
435 };
436 }
437
438 for ($o->{face} || (), @{$anim || []}) {
439 next if /^facings\s/;
440
441 my $face = $_;
442 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
443
444 my $info = $FACEINFO{$face} ||= { };
445 $info->{arc} = $o;
446
447 next if $face =~ /^blank.x11$|^empty.x11$/;
448
449 $info->{visibility} = $visibility if defined $visibility;
450 $info->{magicmap} = $magicmap if defined $magicmap;
451 }
452
453 if (my $smooth = delete $o->{smoothface}) {
454 my %kv = split /\s+/, $smooth;
455 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
456 while (my ($face, $smooth) = each %kv) {
457 $FACEINFO{$smooth}{arc} = $o;
458
459 $FACEINFO{$face}{smooth} = $smooth;
460 $FACEINFO{$face}{smoothlevel} = $level;
461 }
462 }
223 } 463 }
224 } 464 }
225 } 465 }
226 } 466 }
227 467
228 sub process_trs { 468 sub process_trs {
229 while (@trs) { 469 while (my $job = $c_trs->get) {
230 my ($dir, $file) = @{pop @trs}; 470 my ($dir, $file) = @$job;
471 my $path = "$dir/$file";
472
473 my $trs;
474 if (0 > aio_load $path, $trs) {
475 warn "$path: $!, skipping.\n";
476 next;
477 }
478
479 $TRS .= $trs;
480 }
481 }
482
483 my %FILECACHE;
484
485 sub load_cached($;$) {
486 unless (exists $FILECACHE{$_[0]}) {
487 my $data;
488 if (0 < aio_load $_[0], $data) {
489 if ($_[1]) {
490 $data = eval { $_[1]->($data) };
491 warn "$_[0]: $@" if $@;
492 }
493 }
494
495 $FILECACHE{$_[0]} = $data;
496 }
497
498 $FILECACHE{$_[0]}
499 }
500
501 sub process_res {
502 while (my $job = $c_res->get) {
503 my ($dir, $file, $type) = @$job;
504
505 my $data;
506 aio_load "$dir/$file", $data;
507
508 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
509
510 utf8::decode $dir;
511 utf8::decode $file;
512
513 # a meta file for resources is now mandatory
514 unless (exists $meta->{$file}) {
515 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
516 next;
517 }
518
519 $meta = {
520 %{ $meta->{"" } || {} },
521 %{ $meta->{$file} || {} },
522 };
523
524 if ($meta->{license} =~ s/^#//) {
525 $meta->{license} = ({
526 "pd" => "Public Domain",
527 "gpl" => "GNU General Public License, version 3.0 or any later",
528 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
529 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
530 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
531 })->{$meta->{license}}
532 || warn "$dir/$file: license tag '$meta->{license}' not found.";
533 }
534
535 $file =~ s/\.res$//;
536 $file =~ s/\.(ogg|wav|jpg|png)$//;
537
538 substr $dir, 0, 1 + length $PATH, "";
539
540 if (my $filter = $meta->{cfutil_filter}) {
541 if ($filter eq "yaml2json") {
542 $data = JSON::XS::encode_json YAML::XS::Load $data;
543 } elsif ($filter eq "json2json") {
544 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
545 } elsif ($filter eq "perl2json") {
546 $data = eval $data; die if $@;
547 $data = JSON::XS::encode_json $data;
548 } else {
549 warn "$dir/$file: unknown filter $filter, skipping\n";
550 }
551 }
552
553 $RESOURCE{"$dir/$file"} = {
554 type => (exists $meta->{type} ? delete $meta->{type} : $type),
555 data => $data,
556 %$meta ? (meta => $meta) : (),
557 };
231 } 558 }
232 } 559 }
233 560
234 sub find_files; 561 sub find_files;
235 sub find_files { 562 sub find_files {
240 my ($dirs, $nondirs) = @_; 567 my ($dirs, $nondirs) = @_;
241 568
242 find_files "$path/$_" 569 find_files "$path/$_"
243 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 570 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
244 571
572 my $dir = $path;
573 substr $dir, 0, 1 + length $PATH, "";
574
245 for my $file (@$nondirs) { 575 for my $file (@$nondirs) {
576 if ($dir =~ /^music(?:\/|$)/) {
577 $c_res->put ([$path, $file, 3]) # FT_MUSIC
578 if $file =~ /\.(ogg)$/;
579
580 } elsif ($dir =~ /^sound(?:\/|$)/) {
581 $c_res->put ([$path, $file, 5]) # FT_SOUND
582 if $file =~ /\.(wav|ogg)$/;
583
584 } elsif ($dir =~ /^res(?:\/|$)/) {
585 if ($file =~ /\.(jpg|png)$/) {
586 $c_res->put ([$path, $file, 0]) # FT_FACE
587 } elsif ($file =~ /\.(res)$/) {
588 $c_res->put ([$path, $file, 6]) # FT_RSRC
589 } else {
590 $c_res->put ([$path, $file, undef]);
591 }
592
246 if ($file =~ /\.png$/) { 593 } elsif ($file =~ /\.png$/) {
247 push @png, "$path/$file"; 594 push @c_png, ["$path/$file", 0];
595
248 } elsif ($file =~ /\.trs$/) { 596 } elsif ($file =~ /\.trs$/) {
249 push @trs, [$path, $file]; 597 $c_trs->put ([$path, $file]);
598
250 } elsif ($file =~ /\.arc$/) { 599 } elsif ($file =~ /\.arc$/) {
251 push @arc, [$path, $file]; 600 $c_arc->put ([$path, $file]);
601
252 } else { 602 } else {
253 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 603 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
254 } 604 }
255 } 605 }
256 }; 606 };
607 }
608
609 sub generate_plurals {
610# use Lingua::EN::Inflect ();
611# Lingua::EN::Inflect::classical;
612# Lingua::EN::Inflect::def_noun '(.*)staff' => '$1staves'; # policy
613# Lingua::EN::Inflect::def_noun '(.*)boots' => '$1boots'; # hack
614#
615# for my $a (@ARC) {
616# my $name = $a->{name} || $a->{_name};
617#
618# next unless $a->{name_pl};
619# next if $a->{invisible};
620# next if $a->{is_floor};
621# next if $a->{no_pick};
622#
623# my $test = Lingua::EN::Inflect::PL_N_eq $name, Lingua::EN::Inflect::PL $name;
624# my $pl = $test =~ /^(?:eq|p:.)$/
625# ? $name
626# : Lingua::EN::Inflect::PL $name;
627#
628# if ($pl ne $a->{name_pl}) {
629# warn "$a->{_name}: plural differs, $pl vs $a->{name_pl}\n";
630# }
631# }
257 } 632 }
258 633
259 sub inst_arch($) { 634 sub inst_arch($) {
260 my (undef, $path) = @_; 635 my (undef, $path) = @_;
261 636
637 $PATH = $path;
638
639 print "\n",
262 print "installing '$path' to '$DATADIR'\n\n"; 640 "Installing '$path' to '$DATADIR'\n",
641 "\n",
642 "This can take a long time if you run this\n",
643 "for the first time or do not use --cache.\n",
644 "\n",
645 "Unless you run verbosely, all following warning\n",
646 "or error messages indicate serious problems.\n",
647 "\n";
263 648
264 if (!-d "$path/treasures") { 649 if (!-d "$path/treasures") {
265 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 650 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
266 exit 1 unless $FORCE; 651 exit 1 unless $FORCE;
267 } 652 }
268 653
654 print "scanning files...\n" if $VERBOSE;
655
269 find_files $path; 656 find_files $path;
657
658 my @a_arc = map +(async \&process_arc), 1..2;
659 my @a_res = map +(async \&process_res), 1..2;
660 my @a_trs = map +(async \&process_trs), 1..2;
661
270 IO::AIO::flush; 662 IO::AIO::flush;
271 663
272 $_->join for ( 664 $c_res->shutdown;
273 (async \&process_png), (async \&process_png), 665 $c_arc->shutdown;
274 (async \&process_trs), (async \&process_trs), 666 $c_trs->shutdown;
275 (async \&process_arc), (async \&process_arc),
276 );
277 667
668 print "start file scan, arc, res processing...\n" if $VERBOSE;
669
670 $_->join for @a_arc; # need to parse all archetypes before png processing
671
672 print "end arc, start png processing...\n" if $VERBOSE;
673
674 # eight png crunchers work fine for my 4x smp machine
675 my @a_png = map +(async \&process_png), 1..8;
676
677 $_->join for (@a_trs, @a_res, @a_png);
678
679 print "scanning done, processing results...\n" if $VERBOSE;
278 { 680 {
279 open my $fh, ">:utf8", "$DATADIR/animations~" 681 # remove path prefix from editor_folder
280 or die "$DATADIR/animations~: $!"; 682 substr $_->{editor_folder}, 0, 1 + length $path, ""
281 print $fh $ANIM; 683 for values %ARC;
684
685 print "resolving inheritance tree...\n" if $VERBOSE;
686 # resolve inherit
687 while () {
688 my $progress;
689 my $loop;
690
691 for my $o (values %ARC) {
692 if (my $other = $o->{inherit}) {
693 if (my $s = $ARC{$other}) {
694 if ($s->{inherit}) {
695 $loop = $s;
696 } else {
697 delete $o->{inherit};
698 my %s = %$s;
699 delete @s{qw(_name more name name_pl)};
700 %$o = ( %s, %$o );
701 ++$progress;
702 }
703 } else {
704 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
705 delete $ARC{$o->{_name}};
706 }
707 }
708 }
709
710 unless ($progress) {
711 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
712 if $loop;
713
714 last;
715 }
282 } 716 }
283 717
284 { 718 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
719 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
720
721 print "generating plurals...\n" if $VERBOSE;
722 generate_plurals;
723
724 print "writing archetypes...\n" if $VERBOSE;
285 open my $fh, ">:utf8", "$DATADIR/archetypes~" 725 open my $fh, ">:utf8", "$DATADIR/archetypes~"
286 or die "$DATADIR/archetypes~: $!"; 726 or die "$DATADIR/archetypes~: $!";
287 print $fh Crossfire::archlist_to_string \@ARC; 727 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
288 } 728 }
289
290 @PNG = sort { $a->[0] cmp $b->[0] } @PNG;
291 729
292 { 730 {
731 print "writing treasures...\n" if $VERBOSE;
732 open my $fh, ">:utf8", "$DATADIR/treasures~"
733 or die "$DATADIR/treasures~: $!";
734 print $fh $TRS;
735 }
736
737 {
738 print "processing facedata...\n" if $VERBOSE;
739 while (my ($k, $v) = each %FACEINFO) {
740 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
741 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
742
743 #length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
744 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
745
746 if (my $magicmap = $v->{magicmap}) {
747 $magicmap =~ y/A-Z_\-/a-z/d;
748 $v->{magicmap} = $COLOR{$magicmap};
749 }
750
751 delete $v->{arc};
752 }
753
754 print "writing facedata...\n" if $VERBOSE;
293 open my $fh, ">:perlio", "$DATADIR/crossfire.0~" 755 open my $fh, ">:perlio", "$DATADIR/facedata~"
294 or die "$DATADIR/crossfire.0~: $!"; 756 or die "$DATADIR/facedata~: $!";
295 printf $fh "IMAGE %d %d %s\x0a%s", $_, (length $PNG[$_][1]), $PNG[$_][0], $PNG[$_][1] 757
296 for 0.. $#PNG; 758 print $fh freeze {
759 version => 2,
760 faceinfo => \%FACEINFO,
761 animinfo => \%ANIMINFO,
762 resource => \%RESOURCE,
297 } 763 };
764 }
298 765
299 rename "$DATADIR/archetypes~" , "$DATADIR/archetypes"; 766 print "committing files...\n" if $VERBOSE;
300 rename "$DATADIR/crossfire.0~", "$DATADIR/crossfire.0";
301 rename "$DATADIR/animations~" , "$DATADIR/animations";
302 767
303 die "--install-arch not fully implemented\n"; 768 for (qw(archetypes facedata treasures)) {
769 chmod 0644, "$DATADIR/$_~";
770 rename "$DATADIR/$_~", "$DATADIR/$_"
771 or die "$DATADIR/$_: $!";
772 }
773
774 print "archetype data installed successfully.\n";
304 } 775 }
305} 776}
306 777
307Getopt::Long::Configure ("bundling", "no_ignore_case"); 778Getopt::Long::Configure ("bundling", "no_ignore_case");
308GetOptions ( 779GetOptions (

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines